<!DOCTYPE html>
<html lang="zxx">

<head>
  <meta charset="utf-8">
  <title>MDEF | Andrea Bertran_Input devices</title>
  <link rel="icon" type="image/png" href="images/favicomatic/favicon-32x32.png" sizes="32x32" />
  <!-- mobile responsive meta -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

  <!-- ** Plugins Needed for the Project ** -->
  <!-- Bootstrap -->
  <link rel="stylesheet" href="plugins/bootstrap/bootstrap.min.css">
  <link rel="stylesheet" href="plugins/themify/css/themify-icons.css">
  <link rel="stylesheet" href="plugins/counto/animate.css">
  <link rel="stylesheet" href="plugins/aos/aos.css">
  <link rel="stylesheet" href="plugins/owl-carousel/owl.carousel.min.css">
  <link rel="stylesheet" href="plugins/owl-carousel/owl.theme.default.min.css">
  <link rel="stylesheet" href="plugins/magnific-popup/magnific-popup.css">
  <link rel="stylesheet" href="plugins/animated-text/animated-text.css">

  <!-- Main Stylesheet -->
  <link href="css/style.css" rel="stylesheet">

</head>

<body>

<!-- Navigation Start -->
<!-- Header Start -->

<nav class="navbar navbar-expand-lg  main-nav " id="navbar">
    <div class="container">
	  <a class="navbar-brand" href="index.html">
	  	<img src="images/logo_2.png" alt="Image" style="width:170px"; class="img-fluid">
	  </a>


    <button class="navbar-toggler collapsed" type="button" data-toggle="collapse" data-target="#navbarsExample09" aria-controls="navbarsExample09" aria-expanded="false" aria-label="Toggle navigation">
		<span class="ti-align-justify"></span>
	  </button>

  	  <div class="collapse navbar-collapse" id="navbarsExample09">
			<ul class="navbar-nav ml-auto">

      <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="dropdown01" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">Info</a>
          <ul class="dropdown-menu" aria-labelledby="dropdown01">
            <li><a class="dropdown-item" href="about-me.html">About me</a></li>
            <li><a class="dropdown-item" href="contact.html">Contact</a></li>
            <li><a class="dropdown-item" href="https://www.dropbox.com/home/Portfolio?preview=2019.01_Portfolio+Andrea+Bertran.pdf" target="_blank" >Portfolio</a></li>
          </ul>
        </li>

        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="dropdown02" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">MDEF</a>
          <ul class="dropdown-menu" aria-labelledby="dropdown02">
            <li><a class="dropdown-item" href="term1.html">Term 1</a></li>
            <li><a class="dropdown-item" href="term2.html">Term 2</a></li>
            <li><a class="dropdown-item" href="term3.html">Term 3</a></li>
            <li><a class="dropdown-item" href="masterproject.html">Master's project</a></li>
          </ul>
        </li>

      </ul>
      </div>
  </div>
</nav>

<!-- Header Close -->


<!-- Body Open -->
<section class="page-title section pb-0">
  <div class="container">
    <div class="row">
      <div class="col-lg-12">

        <div class="text-left">
          <h2 class="mb-0 text-lg">'Input devices'</h2>
          <span class="date text-sm">04.01.2020</span>
        </div>
      </div>
      </div>
    </div>
  </div>
 </div>
</section>

<section class="section portfolio-single">
	<div class="container">
		<div class="row justify-content-center">
			<div class="col-lg-12">
				<div class="project-info" align="justify">
          <h4>Datasheet</h4>
          <span style="display:block; height: 20px;"></span>
					<p>
            To tell the truth, I'm still having a hard time when reading the <a target="_blank" href="http://ww1.microchip.com/downloads/en/DeviceDoc/ATmega48A-PA-88A-PA-168A-PA-328-P-DS-DS40002061A.pdf"><i>datasheet</i></a>. So, I've been looking for people's explanation on the microcontroller. The most important part for me now, is the use of pins. When to use analog or digital pins. Analog Input Pins can be used almost identically to the digital pins, using the aliases A0, A1, etc... So the result in the code would be a LOW or HIGH variation. The difference is the way we use them to read analog sensors such as temperature, flex (as used in the following exercises), potentiometers or light level sensors. An analog signal varies in voltage levels. The datasheet cautions against "switching analog pins in close temporal proximity to making A/D readings (analogRead) on other analog pins. This can cause electrical noise and introduce jitter in the analog system. It may be desirable, after manipulating analog pins (in digital mode), to add a short delay before using analogRead() to read other analog pins."
            <br><br>
            Other thing I found interesting when reading the datasheet and further read about, is the "Interrupt pins". These two pins, can get the attention of the CPU at any instant. Interrupting the data of ATmega328P. IN0 – INT 0 and INT 1 in <a target="_blank" href="https://andrea_bertran.gitlab.io/andrea.bertran/2020.03.25_Embedded%20programming.html"><i>pinout diagram</i></a>. Even though I didn't use these pins for the following exercises. I'll try them some time to see how they work.
            <br><br>
            And the last thing I could further use and the ATmega328P has is the "Timers modules". According to the datasheet, the microcontroller has two internal timers. They could be used for making counters and generate pulses. Would be nice if I relate the time to the reading of hand gestures as mentioned in the last two exercises. The timers can use the internal and external clock to operate (which I'm not sure what it refers to). And the microcontroller also has an internal pin that could be used to count in relation to the external pulses. OC0B, OC0A, OC1A, OC1B, OC2A, and OC2B in the <a target="_blank" href="https://andrea_bertran.gitlab.io/andrea.bertran/2020.03.25_Embedded%20programming.html"><i>pinout diagram</i></a>.



            <br><br><br><br>
            <h4>Sensors</h4>
            <span style="display:block; height: 20px;"></span>

            At home, I have a few sensors - a potentiometer, a soft potentiometer and a flex sensor (I recently bought an RGB sensor, although by the time I started the activity didn't). As I used the potentiometer during last week, I felt like changing to the flex sensor. To begin I needed to understand the common constants, variables, and functions used for the sensors, so I looked for examples on the web and found a basic <a target="_blank" href="https://www.ardumotive.com/how-to-use-a-flex-sensor-en.html"><i>tutorial</i></a> by "Arduino automotive" copied the code and plugged everything together to see how the sensor reacted when bending.
            <br><br>

            <div id="videoal">
                <div class="video">
                    <video controls>
                        <source src="images/Term_02/Input devices/FlexSensor_1.mp4" type="video/mp4">
                        <source src="Videos.ogg" type="video/ogg">
                    </video>
                </div>

                <div class="video">
                   <video controls>
                       <source src="images/Term_02/Input devices/FlexSensor_2.mp4" type="video/mp4">
                       <source src="Video.ogg" type="video/ogg">
                   </video>
                </div>
              </div>
            <br>
            Nice! So then (shown on the second video), I had to filter the data retrieved by the sensor. Last class, Óscar explained different methods/formulas that are used to filter sensor data. Such as average, gradients, and convolution. To begin I made an average with the data retrieved from the Flex Sensor. In the video, it is hard to notice a big difference. But in reality, I did notice especially on the timing of flashes.

            <br><br>

            I got a bit too excited about this. And I wanted to see if I could place the sensor on my hand and bend it. This took longer than expected... the sensor was falling every time I tried to place it on my hand and when opening the serial monitor in Arduino, I was not able to see anything!!!!!! So, yes... The first thing that came to my mind was using the clothespin to hold down the cables and sensor together as well as making enough pressure to send the data. It worked!

            <br><br>

            <a class="image">
            <img src="images/Term_02/Input devices/FlexSensor_3.jpg" alt="" style="width:1110px" class="img-fluid"></img></a>

            <br><br>

            <video width="1110px" height="" controls>
              <source src="images/Term_02/Input devices/FlexSensor_4.mp4" type="video/mp4">
                <source src="movie.ogg" type="video/ogg">
            </video>

            <br><br>
            The gesture I'm making means "sí" / "yes" in Mexico and if you put close attention to the led and look for a Morse translator you'll find the same answer (or at least I think you will).

            <br><br>
            Files: <ul>
              <li><a href="images/Term_02/Input devices/FlexSensor.rar" download=""> <i>Flex Sensor</i></a></li>
              <li><a href="images/Term_02/Input devices/FlexSensor_filtered.rar" download=""> <i>Flex Sensor filtered</i></a>
              </li>
            </ul>

            <br><br>
            <h4>Making my own sensors</h4>
            <span style="display:block; height: 20px;"></span>
            I saw a few examples on the web of flex sensors attached to gloves, to track gestures. I made my flex sensors (for now only 3) to start experimenting and see the outcomes. I watched some tutorials, but sadly most of them had a lot more things than I can't get now (👑🦠). So, I followed the simplest (the one Edu recommended us to do in <a target="_blank" href="http://academany.fabcloud.io/fabacademy/2020/labs/barcelona/site/local/#material/extras/week09/diysensors"><i>class</i></a>).

            <br><br>

            Steps to be taken:<br><ol>
              <li>Cut around 25/30cm long and 1cm wide, strips of paper (preferably thicker such as cardboard... obviously not to thick otherwise you'll not be able to bend then easily with your fingers).</li>
              <li>Make a half-cut at the center of the strips, for then to bend them.</li>
              <li>Take a pencil (the higher h number the better - I used a 6h) and fill one of the sides of the strip.</li>
              <li>Cut aluminum foil and fold 2 pieces into small thin lines (make them a bit longer for them to reach the opposite side of the paper).</li>
              <li>Paste the aluminum foils on the pencil side. Make sure they are not very close to each other neither touch. To paste them I used double-sided tape.</li>
              <li>Fold the aluminum foils to the opposite side of the paper and bend the paper strip.</li>
              <li>Use masking tape to put both sides of the paper together.</li>
              <li>Solder (This was the hardest part, as the solder wire didn't attach to the aluminum foil) after getting done with it, I put insulating tape and trying to stretch it to the maximum to make pressure on the cables and the aluminum foil tips).</li>
              <li>Test results</li>
            </ol>

            <br>

            <a class="image">
            <img src="images/Term_02/Input devices/OwnSensor_1.jpg" alt="" style="width:545px" class="img-fluid"></img>
            <img src="images/Term_02/Input devices/OwnSensor_2.jpg" alt="" style="width:545px" align="right" class="img-fluid"></img></a>
            <br><br>
            <img src="images/Term_02/Input devices/OwnSensor_3.jpg" alt="" style="width:545px" class="img-fluid"></img>
            <img src="images/Term_02/Input devices/OwnSensor_4.jpg" alt="" style="width:545px" align="right" class="img-fluid"></img></a>

            <br><br>
            <video width="1110px" height="" controls>
              <source src="images/Term_02/Input devices/OwnSensor_5.mp4" type="video/mp4">
                <source src="movie.ogg" type="video/ogg">
            </video>

            <br><br><br><br>
            <h4>Back to the professional sensor</h4>
            On my last presentation for Design Dialogues, I started talking and wondering if it is possible to recreate visual images from sounds and trigger those sounds using gestures. With the intent of redefining visual tools and therefore drawings, paintings or even art. I started using machine learning. I need a lot more hours on coding and training it, so, for now, I paused that path. I'd love to print the visual drawings or geometries that come out from this in braille, emboss or deboss for the blind people and visually impaired touch the outcome of what they can do. But I don't know if I'll have time to do it.

            <br><br>

            Back to FabAcademy, as I wanted to make visuals I needed to find a tutorial that linked sensors to other programming languages. I found <a target="_blank" href="https://learn.sparkfun.com/tutorials/connecting-arduino-to-processing/all"><i>this</i></a>. It is great because lately, I've been falling in love with processing and javascript. First test:

            <br><br>

            <video width="1110px" height="" controls>
              <source src="images/Term_02/Input devices/Ardpro_1.mp4" type="video/mp4">
                <source src="movie.ogg" type="video/ogg">
            </video>

            <br><br>
            Files: <ul>
              <li><a href="images/Term_02/Input devices/ArduinoSensor.rar" download=""> <i>Arduino</i></a></li>
              <li><a href="images/Term_02/Input devices/ProcessingSensor.rar" download=""> <i>Processing</i></a>
              </li>
            </ul>

            I'm not sure if it was in class or outside, but at some point, I came across John Whitney's <a target="_blank" href="https://archive.org/search.php?query=creator%3A%22Whitney%2C+John%2C+Sr.%2C+1917-1995%22"><i>graphics</i></a>. I found them fascinating!! After a while, I searched if anyone had already tried representing similar drawings on processing or javascript and luckily yes! Alexander Miller has one <a target="_blank" href="https://www.youtube.com/watch?v=LaarVR1AOvs"><i>tutorial</i></a>, referencing Whitney's drawings. I don't remember a lot of sin and cos functions, but after playing around with them I could see the outcomes drawing, I changed the value of my sensor a few times to test the different outcomes and in the end I used a variation of multiples and dividends in relation to the numbers of the sin and cos. It worked!

            <br><br>
            <video width="1110px" height="" controls>
              <source src="images/Term_02/Input devices/Ardpro_2.mp4" type="video/mp4">
                <source src="movie.ogg" type="video/ogg">
            </video>

            <br><br>
            <a class="image">
            <img src="images/Term_02/Input devices/Ardpro_3.jpg" alt="" style="width:551px" class="img-fluid"></img>
            <a class="image">
            <img src="images/Term_02/Input devices/Ardpro_4.jpg" alt="" style="width:551px" align="right" class="img-fluid"></img></a>

            <br><br>
            I'm excited to see what other things I can do with the sensors :)

            <br><br>
            Files: <ul>
              <li><a href="images/Term_02/Input devices/ArduinoSensor2.rar" download=""> <i>Arduino</i></a></li>
              <li><a href="images/Term_02/Input devices/ProcessingSensor2.rar" download=""> <i>Processing</i></a>
              </li>
            </ul>


          </p>


<!-- Body Close -->
  <br></br>

        <div class="mt-5">
					<a href="2020.03.25_Embedded programming.html" class="image">
          <img src="images/Izq.png" alt="" style="width:12px" class="img-fluid"></a>

					<a href="2020.04.08_After the nation state.html" class="image">
          <img src="images/Dcha.png" alt="" style="width:12px" align="right" class="img-fluid"></a>
				</div>

			</div>
		</div>
	</div>
</section>

<!-- Footer start -->
<section class="footer">
	<div class="container">
		<div class="row ">
			<div class="col-lg-6">
        <p class="mb-0"> Email. <a href="mailto:andrea.bertran@students.iaac.net"> <b>andrea.bertran@students.iaac.net</b> </a></p>
        ---
        <p class="mb-0">Copyrights © 2019. Designed & Developed by <a target="_blank" href="https://themefisher.com/"> <b>Themefisher</b> </a></p>
        <p class="mb-0">Copyrights © 2019. Owned and modified by <a target="_blank" href="https://fablabbcn.org/" > <b>Iaac-FablabBarcelona</b> </a></p>
			</div>
			<div class="col-lg-6">
				<div class="widget footer-widget text-lg-right mt-5 mt-lg-0">
					<ul class="list-inline mb-0">
						<li class="list-inline-item"><a href="https://www.instagram.com/ablahh/" target="_blank"><i class="ti-instagram mr-3"></i></a>
						</li>
						<li class="list-inline-item"><a href="https://twitter.com/andreablahh" target="_blank"><i class="ti-twitter mr-3"></i></a>
						</li>
            <li class="list-inline-item"><a href="https://ablahh.tumblr.com/" target="_blank"><i class="ti-tumblr mr-3"></i></a>
						</li>
						<li class="list-inline-item"><a href="https://www.linkedin.com/in/andrea-bertran-l%C3%B3pez-57ba43126/" target="_blank"><i class="ti-linkedin mr-3"></i></a></li>
					</ul>
				</div>
			</div>
		</div>
	</div>
</section>
<!-- jQuery -->
<script src="plugins/jQuery/jquery.min.js"></script>
<!-- Bootstrap JS -->
<script src="plugins/bootstrap/bootstrap.min.js"></script>
<script src="plugins/aos/aos.js"></script>
<script src="plugins/owl-carousel/owl.carousel.min.js"></script>
<script src="plugins/shuffle/shuffle.min.js"></script>
<script src="plugins/magnific-popup/jquery.magnific-popup.min.js"></script>
<script src="plugins/animated-text/animated-text.js"></script>
<script src="plugins/counto/apear.js"></script>
<script src="plugins/counto/counTo.js"></script>

 <!-- Google Map -->
<script src="plugins/google-map/map.js"></script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAkeLMlsiwzp6b3Gnaxd86lvakimwGA6UA&callback=initMap"></script>
<!-- Main Script -->
<script src="js/script.js"></script>

</html>
